package kr.co.vividnext.sodalive.can.charge.event

import kr.co.vividnext.sodalive.member.Member
import org.springframework.scheduling.annotation.Async
import org.springframework.stereotype.Component
import org.springframework.transaction.annotation.Propagation
import org.springframework.transaction.annotation.Transactional
import org.springframework.transaction.event.TransactionalEventListener

class ChargeSpringEvent(
    val chargeId: Long,
    val member: Member
)

@Component
class ChargeSpringEventListener(
    private val chargeEventService: ChargeEventService
) {
    @Async
    @TransactionalEventListener
    @Transactional(propagation = Propagation.REQUIRES_NEW)
    fun applyChargeEvent(event: ChargeSpringEvent) {
        chargeEventService.applyChargeEvent(event.chargeId, event.member.id!!)
    }
}
